using Backend.Common;
using Backend.Models;
using Backend.Services.Interface;
using MediatR;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Reflection;
using System.Threading;
using System.Threading.Tasks;

namespace Mediator
{
    public class GetTypeProprieteListHandler : IRequestHandler<GetTypeProprieteListQuery, IEnumerable<TypeProprieteResponse>>
    {
        private readonly ITypeProprieteService _typeProprieteService;
        private readonly ILogger<GetTypeProprieteListHandler> _log;
        public GetTypeProprieteListHandler(ILogger<GetTypeProprieteListHandler> log, ITypeProprieteService typeProprieteService) 
        {
            _log = log;
            _typeProprieteService = typeProprieteService;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public async Task<IEnumerable<TypeProprieteResponse>> Handle(GetTypeProprieteListQuery request, CancellationToken cancellationToken)
        {
            _log.LogDebug($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - Handle of Type");
            if (_typeProprieteService != null) 
            {
                using Task<IEnumerable<TypeProprieteResponse>> task = _typeProprieteService.GetAll();
                await task;
                if (task.IsCompleted && task.IsCompletedSuccessfully)
                {
                    return task.Result;
                }
                else
                {
                    _log.LogError($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - {ErrorsConstants.C_SERVICE_MSG_ERROR + ": Type"}");
                    throw new Exception(ErrorsConstants.C_SERVICE_MSG_ERROR + ": Type");
                }
            }
            else
            {
                _log.LogError($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - {ErrorsConstants.C_APPLICATION_DBCONTEXT_NULL_MSG}");
                throw new ArgumentNullException(ErrorsConstants.C_APPLICATION_DBCONTEXT_NULL_MSG);
            }
        }
    }
}
